Index: /asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/net/net_rename.h
===================================================================
--- /asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/net/net_rename.h	(revision 368)
+++ /asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/net/net_rename.h	(revision 369)
@@ -71,7 +71,7 @@
 #define tget_net_buf_ex		_tinet_tget_net_buf_ex
 #define tget_net_buf		_tinet_tget_net_buf
-#define rel_net_buf		_tinet_rel_net_buf
-#define rus_net_buf		_tinet_rus_net_buf
-#define net_buf_siz		_tinet_net_buf_siz
+#define rel_net_buf			_tinet_rel_net_buf
+#define rus_net_buf			_tinet_rus_net_buf
+#define net_buf_siz			_tinet_net_buf_siz
 #define net_buf_max_siz		_tinet_net_buf_max_siz
 #define nbuf_get_tbl		_tinet_nbuf_get_tbl
Index: /asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netdev/if_btusb/if_btusb.c
===================================================================
--- /asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netdev/if_btusb/if_btusb.c	(revision 368)
+++ /asp3_tinet_ecnl_arm/trunk/asp3_dcre/tinet/netdev/if_btusb/if_btusb.c	(revision 369)
@@ -150,5 +150,5 @@
 
 T_IF_SOFTC if_softc = {
-	{0,},						/* ネットワークインタフェースのアドレス	*/
+	{{0,}},						/* ネットワークインタフェースのアドレス	*/
 	0,							/* 送信タイムアウト			*/
 	&btusb_softc,				/* ディバイス依存のソフトウェア情報	*/
Index: /asp3_tinet_ecnl_arm/trunk/ntshell/echonet/echonet_fbs.c
===================================================================
--- /asp3_tinet_ecnl_arm/trunk/ntshell/echonet/echonet_fbs.c	(revision 368)
+++ /asp3_tinet_ecnl_arm/trunk/ntshell/echonet/echonet_fbs.c	(revision 369)
@@ -416,5 +416,5 @@
 {
 	int ret;
-	
+
 	ret = read_message(fa_id.ptr, fa_id.ptr->hdr.rd, fa_buf, fa_maxlen);
 	fa_id.ptr->hdr.rd += ret;
Index: /asp3_tinet_ecnl_arm/trunk/ntshell/echonet/echonet_udp6_task.c
===================================================================
--- /asp3_tinet_ecnl_arm/trunk/ntshell/echonet/echonet_udp6_task.c	(revision 368)
+++ /asp3_tinet_ecnl_arm/trunk/ntshell/echonet/echonet_udp6_task.c	(revision 369)
@@ -334,5 +334,5 @@
 			break;
 		}
-		
+
 		a_ret = _ecn_udp_cre_res_fbs(fbs_id, ECN_UDP_MSG_GET_IPADDR_RES, &buf);
 		if (a_ret != E_OK) {
Index: /asp3_tinet_ecnl_arm/trunk/ntshell/echonet/echonet_udp_task.c
===================================================================
--- /asp3_tinet_ecnl_arm/trunk/ntshell/echonet/echonet_udp_task.c	(revision 368)
+++ /asp3_tinet_ecnl_arm/trunk/ntshell/echonet/echonet_udp_task.c	(revision 369)
@@ -339,5 +339,5 @@
 			break;
 		}
-		
+
 		a_ret = _ecn_udp_cre_res_fbs(fbs_id, ECN_UDP_MSG_GET_IPADDR_RES, &buf);
 		if (a_ret != E_OK) {
Index: /asp3_tinet_ecnl_arm/trunk/ntshell/fatfs/ff.c
===================================================================
--- /asp3_tinet_ecnl_arm/trunk/ntshell/fatfs/ff.c	(revision 368)
+++ /asp3_tinet_ecnl_arm/trunk/ntshell/fatfs/ff.c	(revision 369)
@@ -4866,5 +4866,5 @@
 	ret = f_vprintf(fp, fmt, arp);
 	va_end(arp);
-	
+
 	return ret;
 }
Index: /asp3_tinet_ecnl_arm/trunk/ntshell/fatfs/ffarch.c
===================================================================
--- /asp3_tinet_ecnl_arm/trunk/ntshell/fatfs/ffarch.c	(revision 368)
+++ /asp3_tinet_ecnl_arm/trunk/ntshell/fatfs/ffarch.c	(revision 369)
@@ -333,5 +333,5 @@
 {
 	BYTE s = 0;
-             
+
 	/* Write protected */
 	if (WP())
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/echonet/echonet_fbs.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/echonet/echonet_fbs.c	(revision 368)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/echonet/echonet_fbs.c	(revision 369)
@@ -416,5 +416,5 @@
 {
 	int ret;
-	
+
 	ret = read_message(fa_id.ptr, fa_id.ptr->hdr.rd, fa_buf, fa_maxlen);
 	fa_id.ptr->hdr.rd += ret;
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/echonet/echonet_udp6_task.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/echonet/echonet_udp6_task.c	(revision 368)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/echonet/echonet_udp6_task.c	(revision 369)
@@ -334,5 +334,5 @@
 			break;
 		}
-		
+
 		a_ret = _ecn_udp_cre_res_fbs(fbs_id, ECN_UDP_MSG_GET_IPADDR_RES, &buf);
 		if (a_ret != E_OK) {
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/echonet/echonet_udp_task.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/echonet/echonet_udp_task.c	(revision 368)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/echonet/echonet_udp_task.c	(revision 369)
@@ -339,5 +339,5 @@
 			break;
 		}
-		
+
 		a_ret = _ecn_udp_cre_res_fbs(fbs_id, ECN_UDP_MSG_GET_IPADDR_RES, &buf);
 		if (a_ret != E_OK) {
Index: /asp3_tinet_ecnl_rx/trunk/ntshell/fatfs/ff.c
===================================================================
--- /asp3_tinet_ecnl_rx/trunk/ntshell/fatfs/ff.c	(revision 368)
+++ /asp3_tinet_ecnl_rx/trunk/ntshell/fatfs/ff.c	(revision 369)
@@ -4866,5 +4866,5 @@
 	ret = f_vprintf(fp, fmt, arp);
 	va_end(arp);
-	
+
 	return ret;
 }